<?php


namespace App\Models;


use App\Entities\RespostaTextual\RespostaTextual;
use App\Utils\Collections\GeneralCollection;

class RespostaTextualModel extends ModelEntity
{
    protected $table = 'resposta_textual';
    protected $primaryKey = 'id';
    protected $returnType = 'array';
    protected $allowedFields = [
        'id_resposta_formulario',
        'resposta',
    ];
    protected $useSoftDeletes = false;
    protected $skipValidation = true;
    protected $useTimestamps = false;


    public function registerRespostaTextualCollection (GeneralCollection $resposta_textual_collection): bool {
        if ($resposta_textual_collection->length === 0) {
            return true;
        }
        $sql = 'INSERT INTO resposta_textual (
                    `id_resposta_formulario`,
                    `resposta`
                ) VALUES ();
        ';
        $values = $resposta_textual_collection->map(function (RespostaTextual $resposta_textual) : string {
            $resposta = trim($this->db->escapeLikeString($resposta_textual->getResposta()));
            return "(
                {$resposta_textual->getIdRESPOSTAFORMULARIO()},   
                \"$resposta\"   
            )";
        })->join(',');
        $sql = str_replace('VALUES ()', "VALUES $values;", $sql);
        $query = $this->db->query($sql);
        return $query->connID->affected_rows === $resposta_textual_collection->length;
    }

    public function updateRespostaTextualCollection (RespostaTextual $resposta_numerica_inteira_collection, int $id_resposta_formulario): bool {
        $data = $resposta_numerica_inteira_collection->toArray(true);
        if (count($data) > 0) {
            $binds = ['id_resposta_formulario' => $id_resposta_formulario];
            $sql = "
                update resposta_textual
            ";
            $sql .= $this->generateUpdateSets($data, $binds);
            $sql .= 'where resposta_textual.id_resposta_formulario = :id_resposta_formulario:';
            $query = $this->db->query($sql, $binds);
            $errors = $this->errors();
            return !$errors;
        } else {
            return true;
        }
    }

    public function updateResposta (array $data, int $id_resposta_formulario): bool {
//        $data = $resposta_numerica_inteira_collection->toArray(true);


        if (count($data) > 0) {
            $resposta = $data["resposta_pergunta_textual"];
            $binds = [
                'resposta' =>$resposta,
                'id' => $id_resposta_formulario,
            ];

            $sql = "update resposta_textual ";
            $sql .= "set resposta_textual.resposta=:resposta: ";
            $sql .= "where resposta_textual.id_resposta_formulario=:id: ";

            $query = $this->db->query($sql, $binds);
            $errors = $this->errors();
            return !$errors;
        } else {
            return true;
        }
    }
}
